function file1_file2_Multiplication,paths1,paths2,D_A,outfiledir,file1,file2,year,year_e,month,month_e,day,day_e,re,out_name

  COMPILE_OPT idl2
  ENVI,/restore_base_save_files
  envi_batch_init,LOG_FILE='batch.log'


  ;获取第一景影像路径
  ;paths1='E:\Data\SM_Products\FY3\B-VSM(2011-2017)\'
  ;image_dir1=DIALOG_PICKFILE(path=paths1,/Directory)
  ;获取第二景影像路径
  ;paths2='E:\Data\SM_Products\ASCAT\G2_BIOPAR_SWI\10km_Daily_V3_Porosity\'
  ;image_dir2=DIALOG_PICKFILE(path=paths2,/Directory)

  ;设置数组
  fid = indgen(2)
  pos = indgen(2)
  dims = indgen(5,2)
  pos[0] = 0
  pos[1] = 0
  ;dims[0,0] = [-1,0,1296-1,0,649-1]
  ;dims[0,1] = [-1,0,1296-1,0,649-1]
  ;记录影像个数
  n=0


  ;搜索一个月的影像个数，记录在n
  ;image_name='*'+D_A+'.tif
  ;file1_s =file_search(image_dir1,image_name,count=file1_num)
  ;file2_s =file_search(image_dir1,image_name,count=file2_num)


  ;设置影像数据初始个数数组，用于存储每个像元的对应的个数，用于后续平局值计算
  NANindexdata = make_array(re[1],re[2],/INTEGER,VALUE=re[0])
  sumdata = make_array(re[1],re[2])
  
  ;  flag1=execute('year1='+year)
  ;  flag2=execute('month1='+month)
  ;  flag3=execute('day1='+day)
  print,re[0],re[1],re[2],year,month,day

  for year1=year,year_e,1 do begin
    for month1=month,month_e,1 do begin
      for day1=day,day_e,1 do begin

        day_s=strcompress(string(day1),/remove)
        month_s=strcompress(string(month1),/remove)
        year_s=strcompress(string(year1),/remove)

        ;获取第一景影像文件
        switch file1 of

          'Fusion': begin

            if month1 lt 10 then begin
              if day1 lt 10 then begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                name1='*'+year_s+'0'+month_s+'0'+day_s+'*'+D_A+'.tif'
              endif else begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                name1='*'+year_s+'0'+month_s+day_s+'*'+D_A+'.tif'
              endelse
            endif else begin
              if day1 lt 10 then begin
                name1='*'+year_s+month_s+'0'+day_s+'*'+D_A+'.tif'
              endif else begin
                name1='*'+year_s+month_s+day_s+'*'+D_A+'.tif
              endelse
            endelse
            BREAK
          end

          'ESACCI': begin

            if month1 lt 10 then begin
              if day1 lt 10 then begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                name1='*'+year_s+'0'+month_s+'0'+day_s+'*'+'.tif'
              endif else begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                name1='*'+year_s+'0'+month_s+day_s+'*'+'.tif'
              endelse
            endif else begin
              if day1 lt 10 then begin
                name1='*'+year_s+month_s+'0'+day_s+'*'+'.tif'
              endif else begin
                name1='*'+year_s+month_s+day_s+'*'+'.tif
              endelse
            endelse
            BREAK
          end
          

          'SMAP': begin            
            switch D_A of
            
            'D':begin
              if month1 lt 10 then begin
                if day1 lt 10 then begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                  ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                  name1='*'+year_s+'0'+month_s+'0'+day_s+'*'+'AM'+'*.tif'
                endif else begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                  name1='*'+year_s+'0'+month_s+day_s+'*'+'AM'+'*.tif'
                endelse
              endif else begin
                if day1 lt 10 then begin
                  name1='*'+year_s+month_s+'0'+day_s+'*'+'AM'+'*.tif'
                endif else begin
                  name1='*'+year_s+month_s+day_s+'*'+'AM'+'*.tif
                endelse
              endelse
             
             break
             end
             
             'A':begin
               if month1 lt 10 then begin
                 if day1 lt 10 then begin
                   ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                   ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                   name1='*'+year_s+'0'+month_s+'0'+day_s+'*'+'PM'+'*.tif'
                 endif else begin
                   ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                   name1='*'+year_s+'0'+month_s+day_s+'*'+'PM'+'*.tif'
                 endelse
               endif else begin
                 if day1 lt 10 then begin
                   name1='*'+year_s+month_s+'0'+day_s+'*'+'PM'+'*.tif'
                 endif else begin
                   name1='*'+year_s+month_s+day_s+'*'+'PM'+'*.tif
                 endelse
               endelse

               break
             end
             
            endswitch            
                       
            BREAK
          end          
          
          'FY3B': begin

            if month1 lt 10 then begin
              if day1 lt 10 then begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                name1='*'+year_s+'0'+month_s+'0'+day_s+'*'+D_A+'.tif'
              endif else begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                name1='*'+year_s+'0'+month_s+day_s+'*'+D_A+'.tif'
              endelse
            endif else begin
              if day1 lt 10 then begin
                name1='*'+year_s+month_s+'0'+day_s+'*'+D_A+'.tif'
              endif else begin
                name1='*'+year_s+month_s+day_s+'*'+D_A+'.tif
              endelse
            endelse
            BREAK
          end

          'SMOS-IC':begin

          if month1 lt 10 then begin
            if day1 lt 10 then begin
              ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
              ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
              name1='*'+'CDF3S'+D_A+'_'+'*'+year_s+'0'+month_s+'0'+day_s+'*.tif'
            endif else begin
              ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
              name1='*'+'CDF3S'+D_A+'_'+'*'+year_s+'0'+month_s+day_s+'*.tif'
            endelse
          endif else begin
            if day1 lt 10 then begin
              name1='*'+'CDF3S'+D_A+'_'+'*'+year_s+month_s+'0'+day_s+'*.tif'
            endif else begin
              name1='*'+'CDF3S'+D_A+'_'+'*'+year_s+month_s+day_s+'*.tif
            endelse
          endelse
          BREAK
        end
        'ASCAT': begin

          if month1 lt 10 then begin
            if day1 lt 10 then begin
              ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
              ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
              name1='*'+year_s+'0'+month_s+'0'+day_s+'*.tif'
            endif else begin
              ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
              name1='*'+year_s+'0'+month_s+day_s+'*.tif'
            endelse
          endif else begin
            if day1 lt 10 then begin
              name1='*'+year_s+month_s+'0'+day_s+'*.tif'
            endif else begin
              name1='*'+year_s+month_s+day_s+'*.tif
            endelse
          endelse
          BREAK
        end

        ELSE:PRINT,'wrong'
      endswitch

      ;获取第二景影像文件
      switch file2 of
        
        'Fusion': begin

          if month1 lt 10 then begin
            if day1 lt 10 then begin
              ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
              ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
              name2='*'+year_s+'0'+month_s+'0'+day_s+'*'+D_A+'.tif'
            endif else begin
              ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
              name2='*'+year_s+'0'+month_s+day_s+'*'+D_A+'.tif'
            endelse
          endif else begin
            if day1 lt 10 then begin
              name2='*'+year_s+month_s+'0'+day_s+'*'+D_A+'.tif'
            endif else begin
              name2='*'+year_s+month_s+day_s+'*'+D_A+'.tif
            endelse
          endelse
          BREAK
        end

        'ESACCI': begin

          if month1 lt 10 then begin
            if day1 lt 10 then begin
              ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
              ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
              name2='*'+year_s+'0'+month_s+'0'+day_s+'*'+'.tif'
            endif else begin
              ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
              name2='*'+year_s+'0'+month_s+day_s+'*'+'.tif'
            endelse
          endif else begin
            if day1 lt 10 then begin
              name2='*'+year_s+month_s+'0'+day_s+'*'+'.tif'
            endif else begin
              name2='*'+year_s+month_s+day_s+'*'+'.tif
            endelse
          endelse
          BREAK
        end


        'SMAP': begin

            switch D_A of
            
            'D':begin
              if month1 lt 10 then begin
                if day1 lt 10 then begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                  ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                  name2='*'+year_s+'0'+month_s+'0'+day_s+'*'+'AM'+'*.tif'
                endif else begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                  name2='*'+year_s+'0'+month_s+day_s+'*'+'AM'+'*.tif'
                endelse
              endif else begin
                if day1 lt 10 then begin
                  name2='*'+year_s+month_s+'0'+day_s+'*'+'AM'+'*.tif'
                endif else begin
                  name2='*'+year_s+month_s+day_s+'*'+'AM'+'*.tif
                endelse
              endelse
             
             break
             end
             
             'A':begin
               if month1 lt 10 then begin
                 if day1 lt 10 then begin
                   ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                   ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                   name2='*'+year_s+'0'+month_s+'0'+day_s+'*'+'PM'+'*.tif'
                 endif else begin
                   ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                   name2='*'+year_s+'0'+month_s+day_s+'*'+'PM'+'*.tif'
                 endelse
               endif else begin
                 if day1 lt 10 then begin
                   name2='*'+year_s+month_s+'0'+day_s+'*'+'PM'+'*.tif'
                 endif else begin
                   name2='*'+year_s+month_s+day_s+'*'+'PM'+'*.tif
                 endelse
               endelse

               break
             end
             
            endswitch
          BREAK
        end
               
        'FY3B':begin

        if month1 lt 10 then begin
          if day1 lt 10 then begin
            ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
            ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
            name2='*'+year_s+'0'+month_s+'0'+day_s+'*'+D_A+'.tif'
          endif else begin
            ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
            name2='*'+year_s+'0'+month_s+day_s+'*'+D_A+'.tif'
          endelse
        endif else begin
          if day1 lt 10 then begin
            name2='*'+year_s+month_s+'0'+day_s+'*'+D_A+'.tif'
          endif else begin
            name2='*'+year_s+month_s+day_s+'*'+D_A+'.tif
          endelse
        endelse
        BREAK
      end

      'SMOS-IC':begin

      if month1 lt 10 then begin
        if day1 lt 10 then begin
          ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
          ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
          name2='*'+'CDF3S'+D_A+'_'+'*'+year_s+'0'+month_s+'0'+day_s+'*.tif'
        endif else begin
          ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
          name2='*'+'CDF3S'+D_A+'_'+'*'+year_s+'0'+month_s+day_s+'*.tif'
        endelse
      endif else begin
        if day1 lt 10 then begin
          name2='*'+'CDF3S'+D_A+'_'+'*'+year_s+month_s+'0'+day_s+'*.tif'
        endif else begin
          name2='*'+'CDF3S'+D_A+'_'+'*'+year_s+month_s+day_s+'*.tif
        endelse
      endelse
      BREAK
    end

    'ASCAT':begin

    if month1 lt 10 then begin
      if day1 lt 10 then begin
        ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
        ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
        name2='*'+year_s+'0'+month_s+'0'+day_s+'*.tif'
      endif else begin
        ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
        name2='*'+year_s+'0'+month_s+day_s+'*.tif'
      endelse
    endif else begin
      if day1 lt 10 then begin
        name2='*'+year_s+month_s+'0'+day_s+'*.tif'
      endif else begin
        name2='*'+year_s+month_s+day_s+'*.tif
      endelse
    endelse
    BREAK
  end
  ELSE:PRINT,'wrong'
endswitch


;读取第一景影像
image_files1=file_search(paths1,name1,count=n1)
ENVI_OPEN_FILE,image_files1,r_fid=fid1, /no_interactive_query, /no_realize
if fid1 eq -1 then begin
  CONTINUE
endif
ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
out_proj1 = envi_get_projection(fid=fid1,pixel_size=out_ps1)
map_info1= envi_get_map_info(fid=fid1)
print,image_files1

data_file1=ENVI_GET_DATA(fid=fid1,dims=dims1,pos=0)
data_file1[where(data_file1 lt 0)]='NAN';SMOS year
data_file1[where(data_file1 gt 0.6)]='NAN'
envi_write_envi_file,data_file1,/IN_MEMORY,map_info=map_info1,/NO_OPEN,/TIFF,R_FID=r_fid_file1


;读取第二景影像
image_files2=file_search(paths2,name2,count=n2)
ENVI_OPEN_FILE,image_files2,r_fid=fid2, /no_interactive_query, /no_realize
if fid2 eq -1 then begin
  CONTINUE
endif
ENVI_FILE_QUERY,fid2,file_type=file_type2,nl=nl2,ns=ns2,dims=dims2,nb=nb2
out_proj2 = envi_get_projection(fid=fid2,pixel_size=out_ps2)
map_info2= envi_get_map_info(fid=fid2)
print,image_files2

data_file2=ENVI_GET_DATA(fid=fid2,dims=dims2,pos=0)
data_file2[where(data_file2 lt 0)]='NAN';SMOS year
data_file2[where(data_file2 gt 0.6)]='NAN'
envi_write_envi_file,data_file2,/IN_MEMORY,map_info=map_info2,/NO_OPEN,/TIFF,R_FID=r_fid_file2

;对第一景和第二景影像进行layerstachking
fid[0] = r_fid_file1
fid[1] = r_fid_file2
dims[0,0] = [-1,0,ns1-1,0,nl1-1]
dims[0,1] = [-1,0,ns2-1,0,nl2-1]

print,file1
print,file2

file=file1+file2
switch file of
  'FY3BFY3B':begin
  exp='float(b1)*float(b2)*0.001*0.001'
  out_ps_layer=out_ps1
  out_proj_layer=out_proj1
  map_info=map_info1
  break
end
'FY3BASCAT':begin
exp='float(b1)*float(b2)*0.001'
out_ps_layer=out_ps2
out_proj_layer=out_proj2
map_info=map_info2
break
end
'FY3BSMOS-IC':begin
exp='float(b1)*float(b2)*0.001'
out_ps_layer=out_ps2
out_proj_layer=out_proj2
map_info=map_info2
break
end
'ASCATASCAT':begin
exp='float(b1)*float(b2)'
out_ps_layer=out_ps2
out_proj_layer=out_proj2
map_info=map_info2
break
end
'ASCATSMOS-IC':begin
exp='float(b1)*float(b2)'
out_ps_layer=out_ps1
out_proj_layer=out_proj1
map_info=map_info1
break
end
'ASCATFY3B':begin
exp='float(b1)*float(b2)*0.001'
out_ps_layer=out_ps1
out_proj_layer=out_proj1
map_info=map_info1
break
end
'SMOS-ICSMOS-IC':begin
exp='float(b1)*float(b2)'
out_ps_layer=out_ps2
out_proj_layer=out_proj2
map_info=map_info2
break
end
'SMOS-ICASCAT':begin
exp='float(b1)*float(b2)'
out_ps_layer=out_ps2
out_proj_layer=out_proj2
map_info=map_info2
break
end
'SMOS-ICFY3B':begin
exp='float(b1)*float(b2)*0.001'
out_ps_layer=out_ps1
out_proj_layer=out_proj1
map_info=map_info1
break
end

'FusionESACCI':begin
  exp='float(b1)*float(b2)'
  out_ps_layer=out_ps1
  out_proj_layer=out_proj1
  map_info=map_info1
  break
end

'FusionSMAP':begin
  exp='float(b1)*float(b2)'
  out_ps_layer=out_ps1
  out_proj_layer=out_proj1
  map_info=map_info1
  break
end

'ESACCISMAP':begin
  exp='float(b1)*float(b2)'
  out_ps_layer=out_ps1
  out_proj_layer=out_proj1
  map_info=map_info1
  break
end

'ESACCIESACCI':begin
  exp='float(b1)*float(b2)'
  out_ps_layer=out_ps1
  out_proj_layer=out_proj1
  map_info=map_info1
  break
end
'SMAPSMAP':begin
  exp='float(b1)*float(b2)'
  out_ps_layer=out_ps1
  out_proj_layer=out_proj1
  map_info=map_info1
  break
end

'FusionFusion':begin
  exp='float(b1)*float(b2)'
  out_ps_layer=out_ps1
  out_proj_layer=out_proj1
  map_info=map_info1
  break
end
endswitch

;    exp='float(b1)*float(b2)*0.001*0.001'
;    out_ps_layer=out_ps1
;    out_proj_layer=out_proj1
;    map_info=map_info1


;bandmath and layerstacking
envi_doit, 'envi_layer_stacking_doit', $
  fid=[r_fid_file1,r_fid_file2],pos=pos, dims=dims, $
  out_dt=5,/in_memory, $
  interp=0,out_ps=out_ps_layer, $
  out_proj=out_proj_layer, r_fid=r_fid

print,exp
envi_doit,'math_doit', $
  fid=[r_fid,r_fid],pos=[0,1],dims=dims, $
  exp=exp,/IN_MEMORY, $
  r_fid=fid_math

;获得影像个数
n=++n

;求取N个file1*file2文件的平均 影像，也就是E(x*y)
ENVI_FILE_QUERY,fid_math, dims=dims_math,ns=ns_math,nl=nl_math
data0=ENVI_GET_DATA(fid=fid_math,dims=dims_math,pos=0)

;设置影像数据初始个数数组，用于存储每个像元的对应的个数，用于后续平局值计算
;NANindexdata = make_array(ns_math,nl_math,/INTEGER,VALUE=n)

data=data0*float(data0 le 0.6)/(data0 le 0.6);AMSR-E/LPRM
data[where(data lt 0)]='NAN';SMOS year
data[where(data gt 0.6)]='NAN'
;搜寻NAN的个数及位置
index = WHERE(FINITE(data,/NAN),count)
;将NAN设置为0，并在位置上个数减去1
if count gt 0 then begin
  data[index] = 0
  NANindexdata[index] = NANindexdata[index] - 1
endif

;获得n景影像累加
sumdata = sumdata + data

ENVI_FILE_MNG,ID=fid1, /REMOVE
ENVI_FILE_MNG,ID=fid2, /REMOVE
ENVI_FILE_MNG,ID=fid_math, /REMOVE
ENVI_FILE_MNG,ID=r_fid, /REMOVE
ENVI_FILE_MNG,ID=r_fid_file1,/REMOVE
ENVI_FILE_MNG,ID=r_fid_file2,/REMOVE
;CLOSE,fid1,fid2
endfor
endfor
endfor

;获得n景影像平均
average=sumdata/NANindexdata

;设置输出文件路径及其名称
;outfiledir='J:\Merging_SM_Products_SMOS_FY3B_ASCAT\TCA_ASCAT_Porostiy\'
;out_name=outfiledir+file1+'_'+file2+'_'+'2015_2017_Average'+'_'+D_A+'.tif
;写入tif文件
envi_write_envi_file,average,out_name=out_name,map_info=map_info,/NO_OPEN,/TIFF

return,out_name

end

