   ;+
   ; :Description:
   ;    Describe the procedure.
   ;    该函数用于根据时间搜索两种土壤水分产品所共用文件数量
   ;    
   ; :Author: xieqiuxia
   ;-
function num_file1_file2,paths1,paths2,D_A,file1,file2,year,year_e,month,month_e,day,day_e
  
  COMPILE_OPT idl2
  ENVI,/restore_base_save_files
  envi_batch_init,LOG_FILE='batch.log'
  
  ;获取第一景影像路径
  ;image_dir1=DIALOG_PICKFILE(path=paths1,/Directory)
  ;获取第二景影像路径
  ;image_dir2=DIALOG_PICKFILE(path=paths2,/Directory)
  
  ;记录影像个数
  n=0
  
  for year1=year,year_e,1 do begin
    for month1=month,month_e,1 do begin
        for day1=day,day_e,1 do begin
          
          day_s=strcompress(string(day1),/remove)
          month_s=strcompress(string(month1),/remove)
          year_s=strcompress(string(year1),/remove)
          
          ;获取第一景影像文件
          switch file1 of
            
            'Fusion': begin

              if month1 lt 10 then begin
                if day1 lt 10 then begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                  ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                  name1='*'+year_s+'0'+month_s+'0'+day_s+'*'+D_A+'.tif'
                endif else begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                  name1='*'+year_s+'0'+month_s+day_s+'*'+D_A+'.tif'
                endelse
              endif else begin
                if day1 lt 10 then begin
                  name1='*'+year_s+month_s+'0'+day_s+'*'+D_A+'.tif'
                endif else begin
                  name1='*'+year_s+month_s+day_s+'*'+D_A+'.tif
                endelse
              endelse
              BREAK
            end

            'ESACCI': begin

              if month1 lt 10 then begin
                if day1 lt 10 then begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                  ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                  name1='*'+year_s+'0'+month_s+'0'+day_s+'*'+'.tif'
                endif else begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                  name1='*'+year_s+'0'+month_s+day_s+'*'+'.tif'
                endelse
              endif else begin
                if day1 lt 10 then begin
                  name1='*'+year_s+month_s+'0'+day_s+'*'+'.tif'
                endif else begin
                  name1='*'+year_s+month_s+day_s+'*'+'.tif
                endelse
              endelse
              BREAK
            end


            'SMAP': begin
            switch D_A of
            
            'D':begin
              if month1 lt 10 then begin
                if day1 lt 10 then begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                  ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                  name1='*'+year_s+'0'+month_s+'0'+day_s+'*'+'AM'+'*.tif'
                endif else begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                  name1='*'+year_s+'0'+month_s+day_s+'*'+'AM'+'*.tif'
                endelse
              endif else begin
                if day1 lt 10 then begin
                  name1='*'+year_s+month_s+'0'+day_s+'*'+'AM'+'*.tif'
                endif else begin
                  name1='*'+year_s+month_s+day_s+'*'+'AM'+'*.tif
                endelse
              endelse
             
             break
             end
             
             'A':begin
               if month1 lt 10 then begin
                 if day1 lt 10 then begin
                   ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                   ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                   name1='*'+year_s+'0'+month_s+'0'+day_s+'*'+'PM'+'*.tif'
                 endif else begin
                   ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                   name1='*'+year_s+'0'+month_s+day_s+'*'+'PM'+'*.tif'
                 endelse
               endif else begin
                 if day1 lt 10 then begin
                   name1='*'+year_s+month_s+'0'+day_s+'*'+'PM'+'*.tif'
                 endif else begin
                   name1='*'+year_s+month_s+day_s+'*'+'PM'+'*.tif
                 endelse
               endelse

               break
             end
             
            endswitch
              BREAK
            end
                        
            'FY3B': begin

              if month lt 10 then begin
                if day lt 10 then begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                  ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                  name1='*'+year_s+'0'+month_s+'0'+day_s+'*'+D_A+'.tif'
                endif else begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                  name1='*'+year_s+'0'+month_s+day_s+'*'+D_A+'.tif'
                endelse
              endif else begin
                if day lt 10 then begin
                  name1='*'+year_s+month_s+'0'+day_s+'*'+D_A+'.tif'
                endif else begin
                  name1='*'+year_s+month_s+day_s+'*'+D_A+'.tif
                endelse
              endelse
              
              BREAK
            end

            'SMOS-IC':begin

            if month lt 10 then begin
              if day lt 10 then begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                name1='*'+'CDF3S'+D_A+'_'+'*'+year_s+'0'+month_s+'0'+day_s+'*.tif'
              endif else begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                name1='*'+'CDF3S'+D_A+'_'+'*'+year_s+'0'+month_s+day_s+'*.tif'
              endelse
            endif else begin
              if day lt 10 then begin
                name1='*'+'CDF3S'+D_A+'_'+'*'+year_s+month_s+'0'+day_s+'*.tif'
              endif else begin
                name1='*'+'CDF3S'+D_A+'_'+'*'+year_s+month_s+day_s+'*.tif
              endelse
            endelse
            BREAK
          end
          'ASCAT': begin

            if month lt 10 then begin
              if day lt 10 then begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                name1='*'+year_s+'0'+month_s+'0'+day_s+'*.tif'
              endif else begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                name1='*'+year_s+'0'+month_s+day_s+'*.tif'
              endelse
            endif else begin
              if day lt 10 then begin
                name1='*'+year_s+month_s+'0'+day_s+'*.tif'
              endif else begin
                name1='*'+year_s+month_s+day_s+'*.tif
              endelse
            endelse
            BREAK
          end

          ELSE:PRINT,'wrong'
        endswitch

        ;获取第二景影像文件
        switch file2 of

          'Fusion': begin

            if month1 lt 10 then begin
              if day1 lt 10 then begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                name2='*'+year_s+'0'+month_s+'0'+day_s+'*'+D_A+'.tif'
              endif else begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                name2='*'+year_s+'0'+month_s+day_s+'*'+D_A+'.tif'
              endelse
            endif else begin
              if day1 lt 10 then begin
                name2='*'+year_s+month_s+'0'+day_s+'*'+D_A+'.tif'
              endif else begin
                name2='*'+year_s+month_s+day_s+'*'+D_A+'.tif
              endelse
            endelse
            BREAK
          end

          'ESACCI': begin

            if month1 lt 10 then begin
              if day1 lt 10 then begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                name2='*'+year_s+'0'+month_s+'0'+day_s+'*'+'.tif'
              endif else begin
                ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                name2='*'+year_s+'0'+month_s+day_s+'*'+'.tif'
              endelse
            endif else begin
              if day1 lt 10 then begin
                name2='*'+year_s+month_s+'0'+day_s+'*'+'.tif'
              endif else begin
                name2='*'+year_s+month_s+day_s+'*'+'.tif
              endelse
            endelse
            BREAK
          end


          'SMAP': begin

            switch D_A of
            
            'D':begin
              if month1 lt 10 then begin
                if day1 lt 10 then begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                  ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                  name2='*'+year_s+'0'+month_s+'0'+day_s+'*'+'AM'+'*.tif'
                endif else begin
                  ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                  name2='*'+year_s+'0'+month_s+day_s+'*'+'AM'+'*.tif'
                endelse
              endif else begin
                if day1 lt 10 then begin
                  name2='*'+year_s+month_s+'0'+day_s+'*'+'AM'+'*.tif'
                endif else begin
                  name2='*'+year_s+month_s+day_s+'*'+'AM'+'*.tif
                endelse
              endelse             
             break
             end
             
             'A':begin
               if month1 lt 10 then begin
                 if day1 lt 10 then begin
                   ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
                   ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
                   name2='*'+year_s+'0'+month_s+'0'+day_s+'*'+'PM'+'*.tif'
                 endif else begin
                   ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
                   name2='*'+year_s+'0'+month_s+day_s+'*'+'PM'+'*.tif'
                 endelse
               endif else begin
                 if day1 lt 10 then begin
                   name2='*'+year_s+month_s+'0'+day_s+'*'+'PM'+'*.tif'
                 endif else begin
                   name2='*'+year_s+month_s+day_s+'*'+'PM'+'*.tif
                 endelse
               endelse
               break
             end
             
            endswitch
            BREAK
          end
          
          'FY3B':begin
          if month lt 10 then begin
            if day lt 10 then begin
              ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
              ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
              name2='*'+year_s+'0'+month_s+'0'+day_s+'*'+D_A+'.tif'
            endif else begin
              ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
              name2='*'+year_s+'0'+month_s+day_s+'*'+D_A+'.tif'
            endelse
          endif else begin
            if day lt 10 then begin
              name2='*'+year_s+month_s+'0'+day_s+'*'+D_A+'.tif'
            endif else begin
              name2='*'+year_s+month_s+day_s+'*'+D_A+'.tif
            endelse
          endelse
          BREAK
        end

        'SMOS-IC':begin

        if month lt 10 then begin
          if day lt 10 then begin
            ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
            ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
            name2='*'+'CDF3S'+D_A+'_'+'*'+year_s+'0'+month_s+'0'+day_s+'*.tif'
          endif else begin
            ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
            name2='*'+'CDF3S'+D_A+'_'+'*'+year_s+'0'+month_s+day_s+'*.tif'
          endelse
        endif else begin
          if day lt 10 then begin
            name2='*'+'CDF3S'+D_A+'_'+'*'+year_s+month_s+'0'+day_s+'*.tif'
          endif else begin
            name2='*'+'CDF3S'+D_A+'_'+'*'+year_s+month_s+day_s+'*.tif
          endelse
        endelse
        BREAK
      end

      'ASCAT':begin

      if month lt 10 then begin
        if day lt 10 then begin
          ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+'0'+day_s+'_D.tif
          ;name1='*'+'11'+'0'+month_s+'0'+day_s+'A'+'*GDAL.tif'
          name2='*'+year_s+'0'+month_s+'0'+day_s+'*.tif'
        endif else begin
          ;outfile=outfiledir+'AMSRU_Mland_'+year_s+'0'+mounth_s+day_s+'_D.tif
          name2='*'+year_s+'0'+month_s+day_s+'*.tif'
        endelse
      endif else begin
        if day lt 10 then begin
          name2='*'+year_s+month_s+'0'+day_s+'*.tif'
        endif else begin
          name2='*'+year_s+month_s+day_s+'*.tif
        endelse
      endelse
      BREAK
    end
    ELSE:PRINT,'wrong'
  endswitch
  
  ;搜索相同文件，并记录个数
  image_files1=file_search(paths1,name1,count=n1)
  image_files2=file_search(paths2,name2,count=n2)
  if (n1 eq 1) and (n2 eq 1) then begin
  n=++n
  endif else begin
    continue
  endelse        

file=file1+file2  
  switch file of
    
    'FY3BFY3B': begin
     image_files_f=file_search(paths1,name1,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
      break
    end
   
    'FY3BASCAT':begin
     image_files_f=file_search(paths2,name2,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
    break
  end
  
  'FY3BSMOS-IC':begin
     image_files_f=file_search(paths2,name2,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
   break
   end
   
 'ASCATFY3B':begin
     image_files_f=file_search(paths1,name1,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
  break
  end
  
  'ASCATSMOS-IC':begin
     image_files_f=file_search(paths1,name1,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
   break
   end
   
  'ASCATASCAT':begin
     image_files_f=file_search(paths1,name1,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
   break
   end
   
  'SMOS-ICFY3B':begin
     image_files_f=file_search(paths1,name1,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
  break
  end
  
  'SMOS-ICASCAT':begin
     image_files_f=file_search(paths2,name2,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
   break
   end
   
  'SMOS-ICSMOS-IC':begin
     image_files_f=file_search(paths1,name1,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
   break
   end

   'FusionESACCI':begin
     image_files_f=file_search(paths1,name2,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
     break
   end
   
   'FusionSMAP':begin
     image_files_f=file_search(paths2,name2,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
     break
   end 
    
   'ESACCISMAP':begin
     image_files_f=file_search(paths2,name1,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
     break
   end
   
   'ESACCIESACCI':begin
     image_files_f=file_search(paths1,name1,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
     break
   end
   
   'SMAPSMAP':begin
     image_files_f=file_search(paths1,name1,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
     break
   end
   
   'FusionFusion':begin
     image_files_f=file_search(paths1,name1,count=n_f)
     ENVI_OPEN_FILE,image_files_f[0],r_fid=fid1, /no_interactive_query, /no_realize
     ENVI_FILE_QUERY,fid1,file_type=file_type1,nl=nl1,ns=ns1,dims=dims1,nb=nb1
     break
   end       
endswitch


ENVI_FILE_MNG,ID=fid1, /REMOVE
;ENVI_FILE_MNG,ID=fid2, /REMOVE

endfor
endfor
endfor
 re=[n,ns1,nl1]
 return,re   
 
 ;print,year,month,day
 


 end